import 'package:lokalise_flutter_sdk/src/ota/data/repositories/local_bundle_repository.dart';
import 'package:lokalise_flutter_sdk/src/ota/domain/models/bundle.dart';

class GetLocalBundleUseCase {
  final LocalBundleRepository _localRepo;

  GetLocalBundleUseCase({
    required LocalBundleRepository localBundleRepository,
  }) : _localRepo = localBundleRepository;

  Future<Bundle> getBundle({
    required String projectId,
    required String appVersion,
  }) async {
    Bundle? bundle;

    try {
      bundle = _localRepo.getBundle();

      if (bundle?.projectId != projectId || bundle?.appVersion != appVersion) {
        await _localRepo.removeBundle();
        bundle = null;
      }
    } catch (_) {
      // nothing to do now, in the future we will send the error to our server
    }

    return bundle ?? Bundle.empty(projectId: projectId, appVersion: appVersion);
  }
}
